'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _cli = require('../../cli');

var route = function route(req, res, next) {
  _cli.abeExtend.hooks.instance.trigger('beforeRoute', req, res, next);
  if (typeof res._header !== 'undefined' && res._header !== null) return;

  var filePath = req.originalUrl.replace('/abe/publish', '');
  var json = req.body.json;

  var p = _cli.cmsOperations.post.publish(filePath, json);

  p.then(function (result) {
    res.set('Content-Type', 'application/json');
    res.send(JSON.stringify(result));
  }, function (result) {
    res.set('Content-Type', 'application/json');
    res.send(JSON.stringify(result));
  }).catch(function (e) {
    console.error('[ERROR] post-publish.js', e);
  });
};

exports.default = route;